"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountWeightDeltaRawMapper = exports.WeightobsvRawMapper = exports.AccountWeightDeltaMongoMapper = exports.WeightobsvMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class WeightobsvMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('accountWeightDeltas', {
            key: 'account_weight_deltas',
            mapper: (values) => values.map(value => new AccountWeightDeltaMongoMapper().fromEntity(value)),
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { account_weight_deltas, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Weightobsv.create(account_weight_deltas?.map(value => new AccountWeightDeltaMongoMapper().toEntity(value)) || [], dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.WeightobsvMongoMapper = WeightobsvMongoMapper;
class AccountWeightDeltaMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('account', {
            key: 'account',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('weightDelta', {
            key: 'weight_delta',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('weightDeltaQuorum', {
            key: 'weight_delta_quorum',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { account, weight_delta, weight_delta_quorum, _id, ...rest } = mongoModel;
        return entities_1.AccountWeightDelta.create(account || '', weight_delta || 0, weight_delta_quorum || 0, _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.AccountWeightDeltaMongoMapper = AccountWeightDeltaMongoMapper;
class WeightobsvRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { account_weight_deltas, dac_id, ...rest } = rawModel;
        return entities_1.Weightobsv.create(account_weight_deltas?.map(value => new AccountWeightDeltaRawMapper().toEntity(value)) || [], dac_id || '', undefined, rest);
    }
}
exports.WeightobsvRawMapper = WeightobsvRawMapper;
class AccountWeightDeltaRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { account, weight_delta, weight_delta_quorum, ...rest } = rawModel;
        return entities_1.AccountWeightDelta.create(account || '', weight_delta || 0, weight_delta_quorum || 0, undefined, rest);
    }
}
exports.AccountWeightDeltaRawMapper = AccountWeightDeltaRawMapper;
