"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Custodians1RawMapper = exports.Custodians1MongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const aw_antelope_1 = require("@alien-worlds/aw-antelope");
const entities_1 = require("../../domain/entities");
class Custodians1MongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('custName', {
            key: 'cust_name',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('requestedpay', {
            key: 'requestedpay',
            mapper: (value) => new aw_antelope_1.AssetMongoMapper().fromEntity(value),
        });
        this.mappingFromEntity.set('totalVotePower', {
            key: 'total_vote_power',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('rank', {
            key: 'rank',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('numberVoters', {
            key: 'number_voters',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('avgVoteTimeStamp', {
            key: 'avg_vote_time_stamp',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { cust_name, requestedpay, total_vote_power, rank, number_voters, avg_vote_time_stamp, _id, ...rest } = mongoModel;
        return entities_1.Custodians1.create(cust_name || '', requestedpay ? new aw_antelope_1.AssetMongoMapper().toEntity(requestedpay) : aw_antelope_1.Asset.getDefault(), total_vote_power || 0, rank || 0, number_voters || 0, avg_vote_time_stamp || new Date(0), _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.Custodians1MongoMapper = Custodians1MongoMapper;
class Custodians1RawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { cust_name, requestedpay, total_vote_power, rank, number_voters, avg_vote_time_stamp, ...rest } = rawModel;
        return entities_1.Custodians1.create(cust_name || '', requestedpay ? new aw_antelope_1.AssetRawMapper().toEntity(requestedpay) : aw_antelope_1.Asset.getDefault(), total_vote_power || 0, rank || 0, number_voters || 0, avg_vote_time_stamp || new Date(0), undefined, rest);
    }
}
exports.Custodians1RawMapper = Custodians1RawMapper;
